%define name yum-repo-client
%define version 1.1
%define unmangled_version 1.1
%define unmangled_version 1.1
%define release 273

Summary: The yum-repo-client is a command line interface for the yum repo server.
Name: %{name}
Version: %{version}
Release: %{release}
Source0: %{name}-%{unmangled_version}.tar.gz
License: GNU GPL v3
Group: Development/Libraries
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Prefix: %{_prefix}
BuildArch: noarch
Vendor: Sebastian Herold, Kay Vogelgesang, Maximilien Riehl, Eric Ihrke <sebastian.herold@immobilienscout24.de, kay.vogelgesang@immobilienscout24.de, maximilien.riehl@immobilienscout24.de, eric.ihrke@immobilienscout24.de>
Requires: python-setuptools python-pycurl bash-completion PyYAML
Url: https://github.com/is24-herold/yum-repo-server

%description
The yum-repo-client is a command line interface for the yum repo server.

%prep
%setup -n %{name}-%{unmangled_version} -n %{name}-%{unmangled_version}

%build
python setup.py build

%install
python setup.py install --single-version-externally-managed -O1 --root=$RPM_BUILD_ROOT --record=INSTALLED_FILES

%clean
rm -rf $RPM_BUILD_ROOT

%post
PYTHON_VERSION=$(/usr/bin/env python -c 'import sys; print(sys.version[:3])')
PYTHON_PACKAGE_DIR=$(/usr/bin/env python -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")

REPOCLIENT_PACKAGE_DIR="$PYTHON_PACKAGE_DIR/yum_repo_client"

if ! [ -d REPOCLIENT_PACKAGE_DIR ]; then
	
	ORIG_PACKAGE_DIR=$(echo $PYTHON_PACKAGE_DIR | sed -e "s/$PYTHON_VERSION/2.6/g")
	
	echo "Linking $ORIG_PACKAGE_DIR/yum_repo_client* to $PYTHON_PACKAGE_DIR"
	ln -s $ORIG_PACKAGE_DIR/yum_repo_client* $PYTHON_PACKAGE_DIR
	
	exit 0
fi

%postun
# in final deinstallation remove symbolic links if exists
if [ "$1" == "0" ]; then

	PYTHON_VERSION=$(/usr/bin/env python -c 'import sys; print(sys.version[:3])')
	PYTHON_PACKAGE_DIR=$(/usr/bin/env python -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")
	
	REPOCLIENT_PACKAGE_DIR="$PYTHON_PACKAGE_DIR/yum_repo_client"
	
	if [ -h $REPOCLIENT_PACKAGE_DIR ]; then
		rm $PYTHON_PACKAGE_DIR/yum_repo_client*
		
		exit 0
	fi 
fi

%files -f INSTALLED_FILES
%defattr(-,root,root)
